#!/bin/ksh
#  Name:     get_fwlog.sh
#  Author:   Jim Edwards
#  Purpose:  Get the fw log text file and load them into Oracle
#  Date:     1 December 1999

################
#Generic FTP procedure to get files from the FW box
################
##CHANGE##  $HOME=/HOMEDIR  ## Change HOMEDIR to the log home dir
. $HOME/.profile
FtpIt()
{
ftp -n fw << MARK
##CHANGE## user USERNAME PASSWORD  ## Change to a username and password that
                                   ##   has access to the firewall log export
                                   ##   file.  I created a special user on
                                   ##   the firewall server for this 
get $FILE
bye
MARK
}

## Main program
# Check to see if the firewall is done exporting the log.  
#  This is done by trying to transfer over the .WORKING file.
#  This file will be present while the export is still going on.
#  Loop until it is gone

FILE=.WORKING
LOG=$HOME/input.log
BU_DATE=`date '+%Y_%m_%d'`
cd /$HOME
date > $LOG
FtpIt  >> $LOG 2>&1
while [ -f $FILE ]
  do
    echo "sleeping"
    sleep 300
    rm $FILE
    FtpIt
  done

# Once the export is finished get the old.log file and load it into Oracle

FILE=fwlog.txt
echo "Getting the log file.\n" >> $LOG

FtpIt >> $LOG 2>&1

ls -l $HOME/fwlog.txt >> $LOG
echo "Total records:  " `wc -l fwlog.txt` >> $LOG
echo "" >> $LOG
echo "Importing to Oracle" >> $LOG

# The firewall puts out the log in a variety of formats so we need to grab
#   the first record of the log file, make a few changes to it and use it to
#   build the control file.  We then use the appropriate control file to
#   load it into Oracle.


cat fw_top.ctl > fw.ctl
head -1 fwlog.txt | sed 's/\;/\,\
/g' | sed 's/\:/2/g' | sed ' s/\-/_/' | sed 's/date/log_date DATE "DDMONYYYY"/' | sed 's/time/log_time DATE "HH24:MI:SS"/' | sed 's/user/username/' | sed 's/\///g' >> fw.ctl
print \) >> fw.ctl

##CHANGE## sqlldr USERNAME/PASSWORD control=fw.ctl log=fwlog.log > /dev/null
                                 ##  Of course, your username and password 

# Archive the log file

cp fwlog.txt old_logs/fwlog.$BU_DATE >> $LOG 2>&1

cat fwlog.txt >> ./trends/week.txt
DAY=`date '+%A'`
if [ $DAY = 'Monday' ]
then
  mv ./trends/week.txt ./trends/lastweek.txt
fi
compress old_logs/fwlog.$BU_DATE >> $LOG 2>&1
# trace hackers
. /u02/fw_arch/sql/trace.sh

# Mail the output to Jim
##CHANGE## mail USERNAME@MAILHOST << END
Subject:  Firewall database import - `date`

`grep -v .WORKING $LOG`

**Oracle SQL*Loader Log**

`cat fwlog.log`

END
