declare
cursor c1 is
    select * 
    from firewall_logs 
    where dst not in ('lamb','txsos-4','ntsvr3')  
    and  src in (select src from
                   firewall_logs group by src
                   having count(src) > 100
                   and  (max(log_time) - min(log_time))< 0.1
                )
    and  trunc(log_date) = trunc(sysdate - 1 )
    order by src,dst;
curr_rec                c1%RowType;
hold_rec                c1%RowType;
unique_flag             char(1) := 'Y';


begin
   open c1;
   fetch c1 into hold_rec;

   if c1%found then
      fetch c1 into curr_rec;

      while c1%found loop
         if  curr_rec.src = hold_rec.src
         and curr_rec.dst != hold_rec.dst then
             if unique_flag = 'Y' then
                insert into temp_fw
                (src, dst, logdt, logtm)
                values
                (hold_rec.src, hold_rec.dst, hold_rec.log_date,
                 hold_rec.log_time);
                unique_flag := 'N';
             end if;
             insert into temp_fw
                (src, dst, logdt, logtm)
                values
                (curr_rec.src, curr_rec.dst, curr_rec.log_date,
                 curr_rec.log_time);
         else
             unique_flag := 'Y';
         end if;

         hold_rec := curr_rec;
         fetch c1 into curr_rec;
      end loop;
   end if;

   commit;
   close c1;
end;
/
