#!/bin/ksh
#  Name:     one_day_load.sh
#  Author:   Jim Edwards
#  Purpose:  Reload an archived file into Oracle
#  Date:     10 December 1999

#Make sure we got the correct # of parameters

if [ $# != 1 ]
then
cat <<foo
  Usage:
      load_fw.sh date (YYYY_MM_DD)
foo
exit 1
fi

#  Set up some variables, uncompress the archived file, copy it to fwlog.txt, 
#    and recompress it.

##CHANGE##  HOME=/HOMEDIR                 ##Change this to your scripts home dir
LOG=$HOME/input.log
BU_DATE=`date '+%Y_%m_%d'`
FILE=$HOME/old_logs/fwlog.$1
date > $LOG

if test -s $FILE.Z
  then 
    uncompress $FILE
    cp $FILE $HOME/fwlog.txt
    compress $FILE
    ls -l $HOME/fwlog.txt >> $LOG
    echo "Total records:  " `wc -l fwlog.txt` >> $LOG
    echo "" >> $LOG
    echo "Importing to Oracle" >> $LOG

    # The firewall puts out the log in a variety of formats so we need to grab
    #   the first record of the log file, make a few changes to it and use it to
    #   build the control file.  We then use the control file to lod the data
    #   into Oracle.


    cat fw_top.ctl > fw.ctl
    head -1 fwlog.txt | sed 's/\;/\,\
/g' | sed 's/\:/2/g' | sed ' s/\-/_/' | sed 's/date/log_date DATE "DDMONYYYY"/' | sed 's/time/log_time DATE "HH24:MI:SS"/' | sed 's/user/username/' | sed 's/\///g' >> fw.ctl
    print \) >> fw.ctl

    ##CHANGE##  sqlldr USERNAME/PASSWORD control=fw.ctl log=fwlog.log  ## Change USERNAME/PASSWORD TO 
                                                                       ##   your DB username/password


# Mail the output to Jim
##CHANGE##  mail EMAIL@ADDRESS << END
Subject:  Firewall database import - `date`

`grep -v .WORKING $LOG`

**Oracle SQL*Loader Log**

`cat fwlog.log`
END
  else
    print "The file $HOME/old_logs/$FILE.Z does not exist.  "
    print "Here are a few things to consider."
    print "You might need to recover it from backup if it is more than a 
    print "month old."
    print "You might have had a brain fart and typed it incorrectly.
    print "  You MUST type the date"
    print "  in the format YYYY_MM_DD (i.e. 2000_02_23)"
    print "or you might just be stupid."
    print "  If this is the case, call Jim so he can make fun of you."
fi
